import 'reflect-metadata';
import type { Type } from '@ingress/core';
import { Ingress, NextFn, forwardRef } from '@ingress/core';
import type { HttpOptions } from '@ingress/http';
import { Http } from '@ingress/http';
import { Route, Router } from '@ingress/router';
import type { Annotation } from 'reflect-annotations';
export { Ingress, Router, Http, Route, NextFn, forwardRef };
export default ingress;
type Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
export type IngressOpts = Prettify<({
    routes?: Type<any>[];
} & Partial<HttpOptions>) | Type<any>[]>;
export declare function ingress(opts?: IngressOpts): {
    readyState: import("@ingress/core").AppState;
    container: import("@ingress/core").ModuleContainer;
    driver: any;
    initializeContext: (ctx: import("@ingress/core").CoreContext) => import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext;
    readonly middleware: import("@ingress/core").ContinuationMiddleware<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, any>;
    unUse: (usable: any) => void;
    finalize: (forwardRefs: Iterable<any>) => Promise<void>;
    use: {
        <Extensions = {}, NewDecorations = {}>(usable: import("@ingress/core").ContextInitializer<Extensions> & import("@ingress/core").Startable<NewDecorations> & Partial<import("@ingress/core").Usable<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, Extensions>>): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations>;
        <Extensions_1 = {}>(usable: import("@ingress/core").ContextInitializer<Extensions_1> & Partial<import("@ingress/core").Usable<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, Extensions_1>>): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_1, {
            http: Http;
        } & {
            router: Router;
        }>;
        <NewDecorations_1 = {}>(usable: import("@ingress/core").Startable<NewDecorations_1> & Partial<import("@ingress/core").Usable<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {}>>): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations_1>;
        (usable: Partial<import("@ingress/core").Usable<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {}>>): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        }>;
        (usable: (context: import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, next: NextFn) => void): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        }>;
        <Extensions_2 extends import("@ingress/core").CoreContext, Decorations>(app: Ingress<Extensions_2, Decorations>): Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_2, {
            http: Http;
        } & {
            router: Router;
        } & Decorations>;
        <U>(annotation: Annotation<U>): U extends import("@ingress/core/lib/cjs/types.js").StartAndExtend<infer Extensions_3, infer NewDecorations_2> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_3, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations_2> : U extends import("@ingress/core").ContextInitializer<infer Extensions_4> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_4, {
            http: Http;
        } & {
            router: Router;
        }> : U extends import("@ingress/core").Startable<infer NewDecorations_3> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations_3> : Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        }>;
        <U_1>(factory: import("reflect-annotations").AnnotationFactory<U_1>): U_1 extends import("@ingress/core/lib/cjs/types.js").StartAndExtend<infer Extensions_5, infer NewDecorations_4> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_5, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations_4> : U_1 extends import("@ingress/core").ContextInitializer<infer Extensions_6> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext & Extensions_6, {
            http: Http;
        } & {
            router: Router;
        }> : U_1 extends import("@ingress/core").Startable<infer NewDecorations_5> ? Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        } & NewDecorations_5> : Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
            http: Http;
        } & {
            router: Router;
        }>;
    };
    start: (app?: Ingress<any, any> | undefined, next?: NextFn | undefined) => Promise<Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, never> & {
        http: Http;
    } & {
        router: Router;
    }>;
    registerDriver: (driver: any, init: import("@ingress/core").Func) => void;
    run: () => Promise<Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, never> & {
        http: Http;
    } & {
        router: Router;
    }>;
    stop: (app?: Ingress<any, any> | undefined, next?: import("@ingress/core").Func<Promise<void>> | undefined) => Promise<Ingress<import("@ingress/core").CoreContext & import("@ingress/http").HttpContext<any> & import("@ingress/router").RouterContext, {
        http: Http;
    } & {
        router: Router;
    }>>;
    readonly [Symbol.toStringTag]: string;
    http: Http;
    router: Router;
    Route: Route;
    Routes: import("@ingress/router").ControllerDependencyCollector;
    Service: import("@ingress/core/lib/cjs/collector.js").DependencyCollector;
    Singleton: import("@ingress/core/lib/cjs/collector.js").DependencyCollector;
    UseSingleton: import("@ingress/core/lib/cjs/collector.js").DependencyCollector;
};
