"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ingress = exports.forwardRef = exports.Route = exports.Http = exports.Router = exports.Ingress = void 0;
require("reflect-metadata");
const core_1 = require("@ingress/core");
Object.defineProperty(exports, "Ingress", { enumerable: true, get: function () { return core_1.Ingress; } });
Object.defineProperty(exports, "forwardRef", { enumerable: true, get: function () { return core_1.forwardRef; } });
const http_1 = require("@ingress/http");
Object.defineProperty(exports, "Http", { enumerable: true, get: function () { return http_1.Http; } });
const router_1 = require("@ingress/router");
Object.defineProperty(exports, "Route", { enumerable: true, get: function () { return router_1.Route; } });
Object.defineProperty(exports, "Router", { enumerable: true, get: function () { return router_1.Router; } });
const lang_js_1 = require("./lang.js");
exports.default = ingress;
function ingress(opts) {
    let routes = undefined, options = undefined;
    if (Array.isArray(opts)) {
        routes = opts;
    }
    else {
        routes = (0, lang_js_1.pick)(opts, 'routes')?.routes;
        options = (0, lang_js_1.pick)(opts, 'listen', 'clientErrorHandler');
    }
    const router = new router_1.Router({ routes }), http = new http_1.Http(options), core = new core_1.Ingress(), app = core.use(http).use(router), result = Object.assign(app, {
        http,
        router,
        Route: router_1.Route,
        Routes: router.Controller,
        Service: app.container.Service,
        Singleton: app.container.SingletonService,
        UseSingleton: app.container.UseSingleton,
    });
    return result;
}
exports.ingress = ingress;
//# sourceMappingURL=ingress.js.map