"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pick = void 0;
function pick(from, ...keys) {
    if (!from)
        return undefined;
    if (typeof from !== 'object' || !from)
        return undefined;
    const picked = {};
    let found = false;
    for (const key of keys) {
        if (Object.hasOwn(from, key)) {
            found = true;
            picked[key] = from[key];
        }
    }
    return found ? picked : undefined;
}
exports.pick = pick;
//# sourceMappingURL=lang.js.map