"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const ingress_js_1 = __importDefault(require("./ingress.js"));
const shot_1 = require("@hapi/shot");
(0, vitest_1.describe)('ingress', () => {
    (0, vitest_1.it)('route parameter injection', async () => {
        const app = (0, ingress_js_1.default)(), { Route, Routes, Service, Singleton } = app;
        let Thing = class Thing {
            value = 'thing';
        };
        Thing = __decorate([
            Service
        ], Thing);
        let Thing2 = class Thing2 {
            value = 'thing2';
        };
        Thing2 = __decorate([
            Singleton
        ], Thing2);
        let Greet = class Greet {
            someRoute(thing) {
                (0, vitest_1.expect)(thing).toEqual({ value: 'thing' });
                return thing.value;
            }
            token(thing, thing2) {
                (0, vitest_1.expect)(thing).toBe(thing2);
                return thing.value;
            }
            scoped(thing, thing2) {
                (0, vitest_1.expect)(thing).toEqual(thing2);
                (0, vitest_1.expect)(thing).not.toBe(thing2);
                return thing.value;
            }
            singleton(thing) {
                (0, vitest_1.expect)(thing).toBe(app.container.get(Thing2));
                return thing.value;
            }
        };
        __decorate([
            Route.Get('inject-type'),
            __param(0, Route.Inject()),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Thing]),
            __metadata("design:returntype", void 0)
        ], Greet.prototype, "someRoute", null);
        __decorate([
            Route.Get('inject-token'),
            __param(0, Route.Inject(Thing)),
            __param(1, Route.Inject()),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Object, Thing]),
            __metadata("design:returntype", void 0)
        ], Greet.prototype, "token", null);
        __decorate([
            Route.Get('inject-transient-scoped'),
            __param(0, Route.Inject({ transient: true })),
            __param(1, Route.Inject()),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Thing, Thing]),
            __metadata("design:returntype", void 0)
        ], Greet.prototype, "scoped", null);
        __decorate([
            Route.Get('inject-transient-singleton'),
            __param(0, Route.Inject({ transient: true })),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Thing2]),
            __metadata("design:returntype", void 0)
        ], Greet.prototype, "singleton", null);
        Greet = __decorate([
            Routes('/')
        ], Greet);
        await app.start();
        void Greet;
        const response = await (0, shot_1.inject)(app.driver, '/inject-type');
        (0, vitest_1.expect)(response.statusCode).toEqual(200);
        (0, vitest_1.expect)(response.payload).toEqual('thing');
        const response2 = await (0, shot_1.inject)(app.driver, '/inject-token');
        (0, vitest_1.expect)(response2.statusCode).toEqual(200);
        (0, vitest_1.expect)(response2.payload).toEqual('thing');
        const response3 = await (0, shot_1.inject)(app.driver, '/inject-transient-scoped');
        (0, vitest_1.expect)(response3.statusCode).toEqual(200);
        (0, vitest_1.expect)(response3.payload).toEqual('thing');
        const response4 = await (0, shot_1.inject)(app.driver, '/inject-transient-singleton');
        (0, vitest_1.expect)(response4.statusCode).toEqual(200);
        (0, vitest_1.expect)(response4.payload).toEqual('thing2');
    });
});
//# sourceMappingURL=route-parameter-injection.test.js.map